/*******************************************************************
*
*  DESCRIPTION: Atomic Model waiter
*
*
*******************************************************************/

#ifndef __WAITER_H
#define __WAITER_H


#include "atomic.h"     // class Atomic

class waiter : public Atomic
{
public:
	waiter( const string &name = "waiter" );					//Default constructor

	virtual string className() const ;
	int order_counter;
	int order_bit;
	int chief1; //1 means available, 0 means unavailable
	int chief2;
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &waiterIn;
	const Port &order;
	Port &waiterOut;

	//out : waiterOut
	//in : waiterIn


	//Port &packetSent;
	//Port &ackReceived;
	Time preparationTime;
	Time preparationTime1;
	Time timeout;

	//int totalPacketNum;
	//int alt_bit;
	bool sending;
//	typedef list<Value> ElementList ;
//	ElementList elements ;

//	Time timeLeft;

};	// class Sender

// ** inline ** //
inline
string waiter::className() const
{
	return "waiter" ;
}

#endif   //__WAITER_H
